PROGRAM READCD; { Turbo Pascal 6.0 }

USES CRT,
     FISCHER;

CONST Max_Bits = 81;

TYPE t_DataBits = ARRAY[1..Max_Bits] OF BOOLEAN;

VAR i         : INTEGER;
    DataBits : t_DataBits;
{}

PROCEDURE CD_Player_initialization;
VAR i : BYTE;
  BEGIN { CD_Player_initialization }
    FOR i := 1 TO Max_Bits DO DataBits[i] := FALSE;
    Motor(3,cw);
    Motor(1,cw);
    Motor(2,ccw);
    REPEAT UNTIL NOT Switch(4);
    Motor(2,cw);
    REPEAT UNTIL Switch(4);
    Motor(2,off);
    REPEAT UNTIL NOT Switch(1);
    REPEAT UNTIL Switch(1);
  END;  { CD_Player_initialization }
{}

PROCEDURE Read_Disk;
VAR i,C,Y : BYTE;
  BEGIN { Read_Disk }
    FOR i := 1 TO 25 DO
      BEGIN
        DataBits[i] := NOT Switch(5);
        C := 0;
        REPEAT
          REPEAT UNTIL     Switch(2); DELAY(2);
          REPEAT UNTIL NOT Switch(2); DELAY(2);
          INC(C);
        UNTIL C = 8;
      END;
    Motor(1,off);

    Y := 0;
    Motor(2,ccw);
    REPEAT
      REPEAT UNTIL     Switch(3);
      REPEAT UNTIL NOT Switch(3);
      INC(Y);
    UNTIL Y = 29;
    Motor(2,off);

    Motor(1,cw);
    FOR i := 26 TO 50 DO
      BEGIN
        DataBits[i] := NOT Switch(5);
        C := 0;
        REPEAT
          REPEAT UNTIL     Switch(2); DELAY(2);
          REPEAT UNTIL NOT Switch(2); DELAY(2);
          INC(C);
        UNTIL C = 8;
      END;
    Motor(1,off);

    Y := 0;
    Motor(2,ccw);
    REPEAT
      REPEAT UNTIL     Switch(3);
      REPEAT UNTIL NOT Switch(3);
      INC(Y);
    UNTIL Y = 29;
    Motor(2,off);

    Motor(1,cw);
    FOR i := 51 TO 75 DO
      BEGIN
        DataBits[i] := NOT Switch(5);
        C := 0;
        REPEAT
          REPEAT UNTIL     Switch(2); DELAY(2);
          REPEAT UNTIL NOT Switch(2); DELAY(2);
          INC(C);
        UNTIL C = 8;
      END;
    Motor(1,off);
    Motor(3,off);
    Motor(2,cw);
    REPEAT UNTIL Switch(4);
    Motor(2,off);
  END;  { Read_Disk }
{}

PROCEDURE Play_Notes;
VAR i,
    Frequency : INTEGER;
  BEGIN { Play_Notes }
    i := 1;
    REPEAT
      Frequency := 0;
      IF DataBits[i  ] THEN Frequency := Frequency + 2*2*2;
      IF DataBits[i+1] THEN Frequency := Frequency +   2*2;
      IF DataBits[i+2] THEN Frequency := Frequency +     2;
      IF DataBits[i+3] THEN Frequency := Frequency +     1;
      SOUND(Frequency * 100);
      DELAY(600);
      NOSOUND;
      INC(i,4);
    UNTIL i > 72;
  END;  { Play_Notes }
{}

BEGIN { Program READCD }
  CLRSCR;
  CD_Player_initialization;
  Read_Disk;
  Play_Notes;
END.  { Program READCD }
