PROGRAM CurveTracer; { Turbo Pascal 6.0 }

USES  CRT,
      DOS,
      Fischer;

CONST Min_Analog_EX     = 70;
      Max_Analog_EX     = 450;
      Analog_Range      = Max_Analog_EX - Min_Analog_EX;
      Max_X_Value    = 200;
      Factor            = Analog_Range / Max_X_Value;

VAR   X,
      Realposition_X : REAL;
      Analoginput : INTEGER;
      Hour,Minute,Second,Hndth_Second,
      Secondmarker                      : WORD;
{}

PROCEDURE CurveTracer_Initialization;
  BEGIN { CurveTracer_Initialization }
    GOTOXY(20,10);
    WRITELN('I N I T I A L I Z A T I O N');
    WHILE NOT Switch(4) DO Motor(1,cw);
    Motor(1,off);
    WHILE Switch(2) DO Motor(2,cw);
    Motor(2,off);
    X              := 0;
    Secondmarker := 0;
    clrscr;
  END;  { CurveTracer_Initialization }
{}

PROCEDURE Linefeed;
  BEGIN { Linefeed }
    GETTIME(Hour,Minute,Second,Hndth_Second);
    IF Second <> Secondmarker
      THEN
        BEGIN
          Motor(3,cw);
          REPEAT UNTIL Switch(3);
          REPEAT UNTIL NOT Switch(3);
          Motor(3,off);
          Secondmarker := Second;
        END;

  END;  { Linefeed }
{}

PROCEDURE Analog_input_read_and_process;
  BEGIN { Analog_input_read_and_process }
    Analoginput := Analog_Input(X_Anal);
    Realposition_X := (Analoginput - Min_Analog_EX) / Factor;
    IF Realposition_X > X
      THEN
        BEGIN
          Motor(1,ccw);
          REPEAT UNTIL Switch(1);
          REPEAT UNTIL NOT Switch(1);
          x:=x+1;
        END;
    IF Realposition_X < X
      THEN
        BEGIN
          Motor(1,cw);
          REPEAT UNTIL Switch(1);
          REPEAT UNTIL NOT Switch(1);
          x:=x-1;
        END;
    Motor(1,off);
    GOTOXY(10,5);
    WRITELN('Position X: ',X:3:1);
    GOTOXY(10,8);
    WRITELN('Realposition X: ',Realposition_X:3:1);
    GOTOXY(10,11);
    WRITELN('Analog_X: ',Analoginput:3);
    GOTOXY(10,17);
    WRITELN('Exit: RETURN')
  END;  { Analog_input_read_and_process }
{}

BEGIN { PROGRAM CurveTracer }
  CLRSCR;
  CurveTracer_Initialization;
  REPEAT
    Analog_input_read_and_process;
    Linefeed;
  UNTIL KEYPRESSED;
  WHILE NOT Switch(2) DO Motor(2,cw);
  Motor(2,off);
  CLRSCR
END.  { PROGRAM CurveTracer }
