Unit FISCHER;

INTERFACE

Uses
  CRT;

  CONST Install_Name      :String[12]='fischer.dat';

  TYPE  Output_Typ        =(Bit_off,Bit_on);
		Motor_Direction_Typ =(on,cw,ccw,off);
		Anal_Typ           =(X_Anal,Y_Anal);
		Digit_Array_Typ    =Array[1..16] of Boolean;      (* 8/16 *)
		Digit_Rec_Typ      =Record
							  E1,
							  E2,
							  E3,
							  E4,
							  E5,
							  E6,
							  E7,
				  E8,
				  E9,
				  E10,
				  E11,
				  E12,
				  E13,
							  E14,
				  E15,
				  E16:Boolean;
							End;
		Install_Field_Typ  =Record
				  Printadr:Word;
							  PC_Func:BYTE;
							End;

 VAR    Digit_Array  :Digit_Array_Typ;
		Digit_Rec    :Digit_Rec_Typ absolute Digit_Array;
		Install_Field :Install_Field_Typ;
		Install_File :File of Install_Field_Typ;

		OutSave      :Byte;
		Printadr     :Word;
		PC_Func      :Byte;
		Moff         :Boolean;

 PROCEDURE Motors_off;
 PROCEDURE Motor(Motor_No:Byte; Motor_Direction:Motor_Direction_Typ);
 FUNCTION  Analog_Input(Anal:Anal_Typ):Word;
 PROCEDURE Input_All_Values(Var Digit_Array);
 FUNCTION  Input_Byte:Byte;
 FUNCTION  Input(Switch_No:Byte):Boolean;
 FUNCTION  Switch(Switch_No : Byte) : BOOLEAN;
 PROCEDURE Output(Motor_No:Byte; Func:Output_Typ);
 FUNCTION  Internal_PCFunc(Anal:Anal_Typ):Byte;
 PROCEDURE Interface_Install;


IMPLEMENTATION

{$L fischpas}

Var Ch:Char;

Procedure Motors_off;            external;
Procedure Motor;                  external;
Function  Analog_Input;         external;
Procedure Input_All_Values;      external;
Function  Input_Byte;           external;
Function  Input;                external;
Procedure Output;                external;
FUNCTION  Internal_PCFunc;        external;
{}

FUNCTION  Switch(Switch_No : BYTE) : BOOLEAN;
  BEGIN
	Input_All_Values(DIGIT_ARRAY);
	Switch := Digit_ARRAY[Switch_No];
  END;
{}

Procedure Interface_Install;

Var
  Printer :Array[1..4] of Word absolute $40:8;
  Addresses  :Byte;
  Port :Word;
  Ch   :Byte;
{ Zeichen :Char; }

Begin
  If Printer[2]=0 then Printadr:=Printer[1]
  else Begin
	If Printer[3]=0 then Addresses:=2 else if Printer[4]=0 then Addresses:=3 else Addresses:=4;
	Writeln('Which printer port are you using?');
	Writeln;
	Write('( 1 , ');
	For Port:=2 to Addresses-1 do Write(Port:1,' , ');
	Writeln(Addresses:1,' )');
	Repeat
	  Ch:=ord(Readkey);
	  If (Ch<49) or (Ch>52) then Ch:=9 else Ch:=Ch-48;
	Until Ch<=Addresses;
	Printadr:=Printer[Ch];
	Writeln;
	Writeln;
	Writeln;
  End;
{ Zeichen:=#32; }
  Writeln('Please connect Interface!');
  Writeln('When ready press any key.');
  Repeat Until Keypressed;
  PC_Func:=Internal_PCfunc(Y_Anal);
  Install_Field.PC_Func:=PC_Func;
  Install_Field.Printadr:=Printadr;
  Assign(Install_File,Install_name);
{$i-}
  Rewrite(Install_File);
{$i+}
  If IOresult=0 then Begin
	Write(Install_File,Install_Field);
	Close(Install_File);
  End
  else Writeln('The Data file was not installed!');
End;


BEGIN { Hp }
  Assign(Install_File,Install_name);
  {$i-} Reset(Install_File); {$i+}
  IF IOresult<>0
	THEN
	  BEGIN
		TextColor(WHITE);
		TextBackGround(BLACK);
		CLRSCR;
		Writeln('Interface set up file ',Install_Name,' not found!');
		Writeln('Make new install file?   (Y/N)');
		Repeat
		  Ch:=Upcase(Readkey);
		Until (Ch='Y') or (Ch='N');
		If Ch='Y'then Interface_Install
					else Halt;
	  END
	ELSE
	  BEGIN
		Read(Install_File,Install_Field);
		Close(Install_File);
		Printadr:=Install_Field.Printadr;
		PC_Func:=Install_Field.PC_Func;
		ClrScr;
	  END;
  Moff:=False;
  Motors_off;
END.  { Hp }

