PROGRAM Plotter; { Turbo Pascal 6.0 }

USES CRT,
     Fischer;

VAR  X_Pos,
     Y_Pos,
     PC_X,
     PC_Y       : INTEGER;
     X_Direction,
     Y_Direction : Motor_Direction_Typ;

{}

PROCEDURE Pen_Down;
  BEGIN { Pen_Down }
    REPEAT
      Motor(3,ccw);
      IF Keypressed THEN HALT;
    UNTIL NOT Switch(4);
    Motor(3 ,off);
  END;  { Pen_Down }
{}

PROCEDURE Pen_Up;
  BEGIN { Pen_Up }
    REPEAT
     Motor(3,cw);
     IF Keypressed THEN HALT;
    UNTIL Switch(4);
    Motor(3 ,off);
  END;  { Pen_Up }
{}

PROCEDURE Plotter_Initialization;
  BEGIN { Plotter_Initialization }
    Motor(4,ccw);
    Pen_Up;
    REPEAT
     Motor(1,cw);
     IF Keypressed THEN HALT;
    UNTIL Switch(3);
    Motor(1,off);
    REPEAT
     Motor(2,cw);
     IF Keypressed THEN HALT;
    UNTIL Switch(2);
    Motor(2,off);

    DELAY(200);
    X_Pos := 0;
    Y_Pos := 0;
    PC_X  := 1;
    PC_Y  := 1;
  END;  { Plotter_Initialization }
{}

PROCEDURE Move_to_XY(X,Y:INTEGER);

  PROCEDURE X_Position_Drive;
    BEGIN { X_Position_Drive }
      CASE PC_X OF
        1 : BEGIN
              IF X > X_Pos THEN BEGIN X_Direction := ccw; Motor(2,ccw); END
                           ELSE BEGIN X_Direction := cw; Motor(2,cw); END;
              INC(PC_X);
            END;
        2 : IF NOT Switch(5) THEN INC(PC_X);
        3 : IF Switch(5)
              THEN
                BEGIN
                  IF X_Direction = ccw THEN INC(X_Pos)
                                        ELSE DEC(X_Pos);
                  IF X = X_Pos
                    THEN
                      BEGIN
                        Motor(2,off);
                        PC_X := 1;
                      END
                    ELSE PC_X := 2;
                END;
      END; { CASE PC_X OF }
    END;  { X_Position_Drive }
  {}

  PROCEDURE Y_Position_Drive;
    BEGIN { Y_Position_Drive }
      CASE PC_Y OF
        1 : BEGIN
              IF Y > Y_Pos THEN BEGIN Y_Direction := ccw; Motor(1,ccw); END
                           ELSE BEGIN Y_Direction := cw; Motor(1,cw); END;
              INC(PC_Y);
            END;
        2 : IF NOT Switch(1) THEN INC(PC_Y);
        3 : IF Switch(1)
              THEN
                BEGIN
                  IF Y_Direction = ccw THEN INC(Y_Pos)
                                        ELSE DEC(Y_Pos);
                  IF Y = Y_Pos
                    THEN
                      BEGIN
                        Motor(1,off);
                        PC_Y := 1;
                      END
                    ELSE PC_Y := 2;
                END;
      END; { CASE PC_Y OF }
    END;  { Y_Position_Drive }
  {}

  BEGIN { Move_to_XY }
    REPEAT
      IF X <> X_Pos THEN X_Position_Drive;
      IF Y <> Y_Pos THEN Y_Position_Drive;
      IF Keypressed THEN HALT;
    UNTIL (X=X_Pos) AND (Y=Y_Pos);
  END;  { Move_to_XY }
{}

BEGIN { PROGRAM Plotter }
  CLRSCR;
  Plotter_Initialization;


  Move_to_XY(20,300);
  Pen_Down;
  Move_to_XY(15,300);
  Move_to_XY(15,250);
  Move_to_XY(20,250);
  Move_to_XY(20,300);
  Pen_Up;
  Move_to_XY(10,300);
  Pen_Down;
  Move_to_XY( 3,300);
  Move_to_XY( 3,250);
  Move_to_XY(10,250);
  Move_to_XY(10,300);
  Pen_Up;
  Move_to_XY(18,200);
  Pen_Down;
  Move_to_XY( 5,200);
  Move_to_XY( 5,100);
  Move_to_XY(18,100);
  Move_to_XY(15,200);
  Pen_Up;
  Move_to_XY(20,150);
  Pen_Down;
  Move_to_XY(20, 30);
  Move_to_XY( 5, 30);
  Move_to_XY( 5,150);
  Move_to_XY(20,150);
  Pen_Up;
  Plotter_Initialization;
END.  { PROGRAM Plotter }
